Attribute VB_Name = "MAddInTools"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

''@B RegisterAddIn
Function RegisterAddIn(sAddIn As String) As Boolean
    Dim s As String, f As Boolean
#If Win32 Then
    Const sSection = "Add-Ins32"
#Else
    Const sSection = "Add-Ins16"
#End If
    Const sIni = "VB.INI": Const cMax = 80
    
    ' Register add-in in VB.INI if it's not already registered
    s = String$(cMax + 1, 0)
    f = GetPrivateProfileString(sSection, sAddIn, _
                                sEmpty, s, cMax, sIni)
    If Not f Then
       f = WritePrivateProfileString(sSection, sAddIn, "0", sIni)
    End If
    RegisterAddIn = f
End Function
''@E RegisterAddIn

Public Function GetInfo(rap As Application) As String
    Dim s As String
    s = "Add-In Name: " & rap.Name & sCrLf & _
        "    Last Used Path: " & rap.LastUsedPath & sCrLf & _
        "    Version: " & rap.Version & sCrLf & _
        "    Full name: " & rap.FullName & sCrLf
    Dim ritems As MenuItems
    Set ritems = rap.AddInMenu.MenuItems
    s = s & "Add-In Menu" & sCrLf
    s = s & GetMenuItems(ritems, 1)
    Dim rproj As ProjectTemplate
    Set rproj = rap.ActiveProject
    s = s & "Project: " & rproj.FileName & _
            IIf(rproj.IsDirty, " (Dirty)", sEmpty) & sCrLf
    s = s & "    Components" & sCrLf
    s = s & GetComponents(rproj.Components, 2)
    s = s & "    Selected Components" & sCrLf
    s = s & GetComponents(rproj.SelectedComponents, 2)
    If Not rproj.ActiveForm Is Nothing Then
        s = s & "    ActiveForm: " & _
                rproj.SelectedComponents(0).FileNames(0) & sCrLf
        s = s & "    ActiveForm" & sCrLf
        s = s & GetForm(rproj.ActiveForm, 2)
    End If

    BugMessage s
    GetInfo = s
End Function

Public Function GetMenuItems(ritems As MenuItems, _
                             ByVal iLevel As Integer) As String
    Dim ritem As Object, s As String
    For Each ritem In ritems
        s = s & Space$(iLevel * 4) & ritem.Caption
        If TypeName(ritem) = "MenuLine" Then
            s = s & " (" & IIf(ritem.Checked, "Checked ", "Unchecked ")
            s = s & IIf(ritem.Enabled, "Enabled", "Disabled") & ")" & sCrLf
        Else
            s = s & sCrLf
            s = s & GetMenuItems(ritem.MenuItems, iLevel + 1)
        End If
    Next
    GetMenuItems = s
End Function

Public Function GetComponents(rcomps As Object, _
                              ByVal iLevel As Integer) As String
    Dim rcomp As Component, s As String
    For Each rcomp In rcomps
        s = s & Space$(iLevel * 4) & rcomp.Name & ":" & _
                rcomp.FileNames(0) & _
                IIf(rcomp.IsDirty, " (Dirty)", sEmpty) & _
                " IconState:" & rcomp.IconState & sCrLf
        If rcomp.FileCount > 1 Then
            s = s & Space$(iLevel * 4) & rcomp.FileNames(1) & sCrLf
        End If
    Next
    GetComponents = s
End Function

Public Function GetForm(rform As FormTemplate, _
                         ByVal iLevel As Integer) As String
    Dim s As String
    s = s & Space$(iLevel * 4) & "Properties" & sCrLf
    s = s & GetProperties(rform.Properties, iLevel + 1)
    s = s & Space$(iLevel * 4) & "Controls" & sCrLf
    s = s & GetControls(rform.ControlTemplates, iLevel + 1)
    GetForm = s
End Function

Public Function GetProperties(rprops As Properties, _
                               ByVal iLevel As Integer) As String
    Dim rprop As Property, s As String, sType As String
    For Each rprop In rprops
        sType = TypeName(rprop.Value)
        Select Case sType
        Case "Integer", "Long", "String", "Single", "Double", "Variant", "Boolean"
            s = s & Space$(iLevel * 4) & sType & ":" & _
                    rprop.Name & " = " & rprop.Value & sCrLf
        'Case "Properties"
        '    s = s & Space$(iLevel * 4) & GetProperties(rprop.Value, iLevel + 4)
        Case Else
            s = s & Space$(iLevel * 4) & sType & ":" & rprop.Name & sCrLf
        End Select
    Next
    GetProperties = s
End Function

Public Function GetControls(rconts As ControlTemplates, _
                               ByVal iLevel As Integer) As String
    Dim rcont As ControlTemplate, s As String
    For Each rcont In rconts
        s = s & Space$(iLevel * 4) & rcont.ClassName & sCrLf
        s = s & GetProperties(rcont.Properties, iLevel + 1)
    Next
    GetControls = s
End Function

Function ErrorBox(e As Object) As Integer
    Dim s As String
    s = s & "Number: " & e.Number & sCrLf
    s = s & "Description: " & e.Description & sCrLf
    s = s & "Source: " & e.Source & sCrLf
    ErrorBox = MsgBox(s)
End Function

Function CodeHandle(sName As String) ' As SysInt
    CodeHandle = FindWindow("VBCodeWin", sName)
End Function
