VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CFileHandler"
Attribute VB_Creatable = False
Attribute VB_Exposed = True
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses ADDINMAN.CLS

''@B Internal
Private hConnect As Long
Private rman As CAddInManager
Private rap As Application
''@E Internal

Const cMaxEntries = 100

''@B Create
Function Create(rmanA As CAddInManager) As Boolean
    On Error GoTo CreateFail
    Set rman = rmanA
    Set rap = rman.Application
    ''@B ConnectEvents
    hConnect = rap.Application.FileControl.ConnectEvents(Me)
    ''@E ConnectEvents
    If hConnect Then Create = True
CreateFail:
End Function
''@E Create

''@B Destroy
Sub Destroy()
    On Error Resume Next
    rap.Application.FileControl.DisconnectEvents hConnect
End Sub
''@E Destroy

''@B Standard
Property Get Application() As Application
    Set Application = rap
End Property

Property Get Parent() As CAddInManager
    Set Parent = rman
End Property

Property Get Manager() As CAddInManager
    Set Manager = rman
End Property
''@E Standard

' Standard event handlers log the events
' Add code for additional functionality
    
Public Sub AfterAddFile(FileName As String)
    LogEntry "AfterAddFile:", "FileName", FileName
    ' Put your event code here
End Sub

Public Sub AfterChangeFileName(FileType As Integer, _
                               NewName As String, OldName As String)
    LogEntry "AfterChangeFileName:", "FileType", FileTypeStr(FileType)
    LogEntry sEmpty, "NewName", NewName
    LogEntry sEmpty, "OldName", OldName
    ' Put your event code here
End Sub

Public Sub AfterCloseFile(FileNames() As String)
    Dim iLo As Integer, iHi As Integer, i As Integer
    iLo = LBound(FileNames): iHi = UBound(FileNames)
    LogEntry "AfterCloseFile:", "FileNames(" & iLo & ")", FileNames(iLo)
    For i = iLo + 1 To iHi
        LogEntry sEmpty, "FileNames(" & i & ")", FileNames(i)
    Next
    ' Put your event code here
End Sub

Public Sub AfterRemoveFile(FileName As String)
    LogEntry "AfterRemoveFile:", "FileName", FileName
    ' Put your event code here
End Sub

Public Sub AfterWriteFile(FileName As String, Success As Integer)
    LogEntry "AfterWriteFile:", "FileName", FileName
    LogEntry sEmpty, "Success", SuccessStr(Success)
    ' Put your event code here
End Sub

''@B BeforeLoadFile
Public Sub BeforeLoadFile(FileNames() As String)
    Dim iLo As Integer, iHi As Integer, i As Integer
    iLo = LBound(FileNames): iHi = UBound(FileNames)
    LogEntry "BeforeLoadFile:", "FileNames(" & iLo & ")", _
             FileNames(iLo)
    For i = iLo + 1 To iHi
        LogEntry sEmpty, "FileNames(" & i & ")", FileNames(i)
    Next
    ' Put your event code here
End Sub
''@E BeforeLoadFile

Public Sub DoGetAddFileName(FileNames() As String, _
                            CancelDefault As Boolean)
    Dim iLo As Integer, iHi As Integer, i As Integer
    iLo = LBound(FileNames): iHi = UBound(FileNames)
    LogEntry "DoGetAddFileName:", "FileNames(" & iLo & ")", _
             FileNames(iLo)
    For i = iLo + 1 To iHi
        LogEntry sEmpty, "FileNames(" & i & ")", FileNames(i)
    Next
    LogEntry sEmpty, "CancelDefault", CancelDefault
    ' Put your event code here
End Sub

Public Sub DoGetNewFileName(FileType As Integer, NewName As String, _
                            OldName As String, CancelDefault As Boolean)
    LogEntry "DoGetNewFileName:", "FileType", FileTypeStr(FileType)
    LogEntry sEmpty, "NewName", NewName
    LogEntry sEmpty, "OldName", OldName
    LogEntry sEmpty, "CancelDefault", CancelDefault
    ' Put your event code here
End Sub

Public Sub DoGetOpenProjectName(ProjectName As String, _
                                CancelDefault As Boolean)
    LogEntry "DoGetOpenProjectName:", "ProjectName", ProjectName
    LogEntry sEmpty, "CancelDefault", CancelDefault
    ' Put your event code here
End Sub

Public Sub RequestChangeFileName(FileType As Integer, NewName As String, _
                                 OldName As String, Cancel As Boolean)
    LogEntry "RequestChangeFileName:", "FileType", FileTypeStr(FileType)
    LogEntry sEmpty, "NewName", NewName
    LogEntry sEmpty, "OldName", OldName
    LogEntry sEmpty, "Cancel", Cancel
    ' Put your event code here
End Sub

Public Sub RequestWriteFile(FileName As String, Cancel As Boolean)
    LogEntry "RequestWriteFile:", "FileName", FileName
    LogEntry sEmpty, "Cancel", Cancel
    ' Put your event code here
End Sub

' Display event to logfile, listbox, and/or debug window
Private Sub LogEntry(sEvent As String, sName As String, _
                     ByVal sData As String)
    Manager.Commands.LogEntry sEvent, sName, sData
End Sub

'Converter for FileType variables to a string explanation
Private Function FileTypeStr(ordFileType As Integer) As String
    Select Case ordFileType
    Case 0
        FileTypeStr = "Form"
    Case 1
        FileTypeStr = "Module"
    Case 2
        FileTypeStr = "Class"
    Case 3
        FileTypeStr = "Project"
    Case 4
        FileTypeStr = ".EXE"
    Case Else
        'BugAssert False
    End Select
End Function

'Converter for Success variables to a string explanation
Private Function SuccessStr(ByVal Success As Integer) As String
    Select Case Success
    Case 0
        SuccessStr = "Yes"
    Case 1
        SuccessStr = "Write was cancelled"
    Case 2
        SuccessStr = "Write failed"
    Case Else
        'BugAssert False
    End Select
End Function
