Attribute VB_Name = "MGDITool"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses WINTYPE.BAS

#If Win32 Then
Public Type TLogBrush
    Style As Long
    Color As Long
    Hatch As Long
End Type

Public Type TLogPen
    Style As Long
    Width As TPoint
    Color As Long
End Type

Public Type TBitmap
    Type As Long
    Width As Long
    Height As Long
    WidthBytes As Long
    PLANES As Integer
    BITSPIXEL As Integer
    Bits As Long
End Type

Public Type TIconInfo
    fIcon As Long
    xHotspot As Long
    yHotspot As Long
    hbmMask As Long
    hbmColor As Long
End Type

#Else

Public Type TLogBrush
    Style As Integer
    Color As Long
    Hatch As Integer
End Type

Public Type TLogPen
    Style As Integer
    Width As TPoint
    Color As Long
End Type

''@B TBitmap
Public Type TBitmap
    Type As Integer
    Width As Integer
    Height As Integer
    WidthBytes As Integer
    PLANES As Byte
    BITSPIXEL As Byte
    Bits As Long
End Type
''@E TBitmap

#End If

#If Win32 Then
Declare Function PolyBezier Lib "GDI32" (ByVal hDC As Long, _
    lppt As TPoint, ByVal cPoints As Long) As Long
Declare Function PolyBezierTo Lib "GDI32" (ByVal hDC As Long, _
    lppt As TPoint, cPoints As Long) As Long

Declare Function Polygon Lib "GDI32" (ByVal hDC As Long, _
    lppt As TPoint, ByVal cPoints As Long) As Long
Declare Function GetWindowExtEx Lib "GDI32" (ByVal hWnd As Long, _
    lpSize As TSize) As Long
Declare Function GetObjectBrush Lib "GDI32" Alias "GetObjectA" ( _
    ByVal hObject As Long, ByVal nCount As Long, _
    lpvObject As TLogBrush) As Long
Declare Function GetObjectPen Lib "GDI32" Alias "GetObjectA" ( _
    ByVal hObject As Long, ByVal nCount As Long, _
    lpvObject As TLogPen) As Long
Declare Function GetObjectBitmap Lib "GDI32" Alias "GetObjectA" ( _
    ByVal hObject As Long, ByVal nCount As Long, _
    lpvObject As TBitmap) As Long
Declare Function CreateIconIndirect Lib "USER32" ( _
    piconinfo As TIconInfo) As Long
Declare Function GetIconInfo Lib "USER32" ( _
    ByVal hIcon As Long, piconinfo As TIconInfo) As Long
#Else
''@B Polygon
Declare Function Polygon Lib "GDI" (ByVal hDC As Integer, _
    lppt As TPoint, ByVal cPoints As Integer) As Integer
''@E Polygon
Declare Function GetWindowExtEx Lib "GDI" (ByVal hWnd As Integer, _
    lpSize As TSize) As Integer
''@B GetObjects
Declare Function GetObjectBrush Lib "GDI" Alias "GetObject" ( _
    ByVal hObject As Integer, ByVal nCount As Integer, _
    lpvObject As TLogBrush) As Integer
Declare Function GetObjectPen Lib "GDI" Alias "GetObject" ( _
    ByVal hObject As Integer, ByVal nCount As Integer, _
    lpvObject As TLogPen) As Integer
Declare Function GetObjectBitmap Lib "GDI" Alias "GetObject" ( _
    ByVal hObject As Integer, ByVal nCount As Integer, _
    lpvObject As TBitmap) As Integer
''@E GetObjects
#End If

''@B VBPolygon
Function VBPolygon(ByVal hDC, aPoint() As TPoint) As Boolean
    Dim apt() As TPoint, i, iMax, iMin ' As SysInt
    iMax = UBound(aPoint): iMin = LBound(aPoint)
    ' Create array of pixel-adjusted points
    ReDim apt(iMin To iMax) As TPoint
    For i = iMin To iMax
        apt(i).x = aPoint(i).x / Screen.TwipsPerPixelX
        apt(i).y = aPoint(i).y / Screen.TwipsPerPixelY
    Next
    ' Pass first element and count to Polygon
    VBPolygon = Polygon(hDC, apt(iMin), iMax - iMin + 1)
End Function
''@E VBPolygon

''@B VBFloodFill
Function VBFloodFill(ByVal hDC, ByVal x, ByVal y, _
                     ByVal clr As Long) As Boolean
    VBFloodFill = FloodFill(hDC, x / Screen.TwipsPerPixelX, _
                                 y / Screen.TwipsPerPixelY, clr)
End Function
''@E VBFloodFill

' Create combined ROP for MaskBlt
Function MakeRop4(ropFore As Long, ropBack As Long) As Long
    ' MakeRop4 = ((ropBack SHL 8) And &HFF000000) Or ropFore
#If 1 Then
    MakeRop4 = (LShiftDWord(ropBack, 8) And &HFF000000) Or ropFore
#Else
    ' Hack to do same shift in Basic
    If ropBack And &H800000 Then
        Dim ropTmp As Long
        ' Remove high bit
        ropTmp = (ropBack And &HFF7FFFFF)
        ' Do calculation
        ropTmp = ((ropTmp * 256) And &HFF000000) Or ropFore
        ' Put high bit back in
        MakeRop4 = ropTmp Or &H80000000
    Else
        MakeRop4 = ((ropBack * 256) And &HFF000000) Or ropFore
    End If
#End If
End Function

' Fake MoveTo API implemented with MoveToEx with null pointer for return
#If Win32 Then
Function MoveTo(ByVal hDC, ByVal x, ByVal y) ' Arguments and return SysInt
    MoveToNull hDC, x, y, pNull
End Function
#End If
