Attribute VB_Name = "MSettings"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$Uses PARSE.BAS

''@B TWindowPlacement
#If Win32 Then
Private Type TWindowPlacement
    length As Long
    Flags As Long
    showCmd As Long
    ptMinPosition As TPoint
    ptMaxPosition As TPoint
    rcNormalPosition As TRect
End Type
#Else
Private Type TWindowPlacement
    length As Integer
    Flags As Integer
    showCmd As Integer
    ptMinPosition As TPoint
    ptMaxPosition As TPoint
    rcNormalPosition As TRect
End Type
#End If
''@E TWindowPlacement

#If Win32 Then

Declare Function SetWindowPlacement Lib "USER32" ( _
    ByVal hWnd As Long, lpwndpl As TWindowPlacement) As Long
Declare Function GetWindowPlacement Lib "USER32" ( _
    ByVal hWnd As Long, lpwndpl As TWindowPlacement) As Long

#Else

''@B WindowPlacement
Declare Function SetWindowPlacement Lib "User" ( _
    ByVal hWnd As Integer, lpwndpl As TWindowPlacement) As Integer
Declare Function GetWindowPlacement Lib "User" ( _
    ByVal hWnd As Integer, lpwndpl As TWindowPlacement) As Integer
''@E WindowPlacement

#End If

Const sSep = ","
Const sWinSection = "Window List"
Const sCtlSection = "Control List"

Sub RestoreWindow(ByVal hWnd, sTitle As String)
    Dim sValue As String, f As Integer

    sValue = GetSetting(App.EXEName, sWinSection, sTitle, sEmpty)
    ' Quit if no entry
    If sValue = sEmpty Then Exit Sub

    Dim wp As TWindowPlacement, iPos As Integer
    wp.showCmd = Val(GetToken(sValue, sSep))
    ' wp.Flags = 0 (no flags required)
    wp.ptMinPosition.X = Val(GetToken(sEmpty, sSep))
    wp.ptMinPosition.Y = Val(GetToken(sEmpty, sSep))
    wp.ptMaxPosition.X = Val(GetToken(sEmpty, sSep))
    wp.ptMaxPosition.Y = Val(GetToken(sEmpty, sSep))
    wp.rcNormalPosition.Left = Val(GetToken(sEmpty, sSep))
    wp.rcNormalPosition.Top = Val(GetToken(sEmpty, sSep))
    wp.rcNormalPosition.Right = Val(GetToken(sEmpty, sSep))
    wp.rcNormalPosition.Bottom = Val(GetToken(sEmpty, sSep))
    ''@B CallSetWindowPlacement
    ' Remember to set length
    wp.length = Len(wp)
    ' Send all your settings to the system
    f = SetWindowPlacement(hWnd, wp)
    ''@E CallSetWindowPlacement

End Sub

Sub SaveWindow(ByVal hWnd, sTitle As String)
    
    Dim sValue As String, f As Boolean
''@B CallGetWindowPlacement
    Dim wp As TWindowPlacement
    ' First set type length for Windows
    wp.length = Len(wp)
    ' Get coordinates and other data about the window
    f = GetWindowPlacement(hWnd, wp)
    ' Read and use the data
    sValue = wp.showCmd & ","
''@E CallGetWindowPlacement
    sValue = sValue & wp.ptMinPosition.X & ","
    sValue = sValue & wp.ptMinPosition.Y & ","
    sValue = sValue & wp.ptMaxPosition.X & ","
    sValue = sValue & wp.ptMaxPosition.Y & ","
    sValue = sValue & wp.rcNormalPosition.Left & ","
    sValue = sValue & wp.rcNormalPosition.Top & ","
    sValue = sValue & wp.rcNormalPosition.Right & ","
    sValue = sValue & wp.rcNormalPosition.Bottom
    
    SaveSetting App.EXEName, sWinSection, sTitle, sValue

End Sub

Sub ClearWindowSetting(sTitle As String)
    DeleteSetting App.EXEName, sWinSection, sTitle
End Sub

' These could have been implemented with Form properties, but
' API does a better job of handling minimized and maximized windows.

' Call only in Form_Load before Show
Sub RestoreForm(frm As Form, Optional vTitle As Variant)
    If IsMissing(vTitle) Then vTitle = frm.Caption
    RestoreWindow frm.hWnd, CStr(vTitle)
End Sub

' Call only in Form_Unload when form is closing
Sub SaveForm(frm As Form, Optional vTitle As Variant)
    If IsMissing(vTitle) Then vTitle = frm.Caption
    SaveWindow frm.hWnd, CStr(vTitle)
End Sub

Sub ClearFormSetting(frm As Form, Optional vTitle As Variant)
    If IsMissing(vTitle) Then vTitle = frm.Caption
    DeleteSetting App.EXEName, sWinSection, vTitle
End Sub

Sub RestoreCtl(ctl As Control, sTitle As String)
With ctl
    Dim sValue As String, s As String, i As Long
    sValue = GetSetting(App.EXEName, sCtlSection, sTitle, sEmpty)
    ' Quit if no entry
    If sValue = sEmpty Then Exit Sub

    ' Set left and top while in normal mode
    On Error Resume Next
    .Left = Val(GetToken(sValue, sSep))
    .Top = Val(GetToken(sEmpty, sSep))
    .Width = Val(GetToken(sEmpty, sSep))
    .Height = Val(GetToken(sEmpty, sSep))
    .Enabled = GetToken(sEmpty, sSep)
    .Visible = GetToken(sEmpty, sSep)
    s = .Caption
    If Err = 0 Then .Caption = GetToken(sEmpty, sSep)
    i = .BackColor
    If Err = 0 Then .BackColor = GetToken(sEmpty, sSep)
    i = .ForeColor
    If Err = 0 Then .ForeColor = GetToken(sEmpty, sSep)
    ' Enhance to restore anything else you saved

End With
End Sub

Sub SaveCtl(ctl As Control, sTitle As String)
With ctl
    Dim sValue As String, s As String, i As Long

    On Error Resume Next
    sValue = sValue & .Left & "," & .Top & ","
    sValue = sValue & .Width & "," & .Height & ","
    sValue = sValue & .Enabled & ","
    sValue = sValue & .Visible & ","
    s = .Caption
    If Err = 0 Then sValue = sValue & .Caption & ","
    i = .BackColor
    If Err = 0 Then sValue = sValue & .BackColor & ","
    i = .ForeColor
    If Err = 0 Then sValue = sValue & .ForeColor & ","
    
    ' Enhance to save anything else you need

    SaveSetting App.EXEName, sCtlSection, sTitle, sValue

End With
End Sub

' Add more save and restore functions:
'     SaveFont/RestoreFont
'     SaveTextBox/RestoreTextBox
