VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CSharedString"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

'$ Uses UTILITY.BAS

Private h As Long, p As Long, e As Long
Const MEM_HANDLE As Long = -1&

''@B Create
Function Create(sName As String) As Boolean
    ' Create = False
    If sName = sEmpty Then Exit Function
    ' Try to create file mapping of 65535 (only used pages matter)
    h = CreateFileMapping(MEM_HANDLE, pNull, PAGE_READWRITE, _
                          0, 65535, sName)
    e = Err.LastDllError
    ' Unknown error, bail out
    If h = hNull Then Destroy: Exit Function
    
    ' Get pointer to mapping
    p = MapViewOfFile(h, FILE_MAP_WRITE, 0, 0, 0)
    If p = pNull Then e = Err.LastDllError: Exit Function
    If e <> ERROR_ALREADY_EXISTS Then
        ' Set size of new file mapping to 0 by copying first 4 bytes
        Dim c As Long ' = 0
        CopyMemory ByVal p, c, 4
    ' Else
        ' Existing file mapping
    End If
    e = 0
    Create = True
End Function
''@E Create

''@B Data
Property Get Data() As String
    If h = hNull Then e = ERROR_INVALID_DATA: Exit Property
    BugAssert p <> pNull
    
    ' Copy length out of first 4 bytes of data
    Dim c As Long, sData As String
    CopyMemory c, ByVal p, 4
    ' Copy rest of memory into string
    If c = 0 Then Exit Property ' Data = sEmpty
    sData = String$(c, 0)
    CopyMemory ByVal sData, ByVal (p + 4), c
    Data = sData
End Property

Property Let Data(s As String)
    If h = hNull Then e = ERROR_INVALID_DATA: Exit Property
    BugAssert p <> pNull

    Dim c As Long
    c = Len(s)
    ' Copy length to first 4 bytes and string to remainder
    CopyMemory ByVal p, c, 4
    CopyMemory ByVal (p + 4), ByVal s, c
End Property
''@E Data

Property Get LastErr() As Long
    LastErr = e
End Property

''@B Destroy
Private Sub Destroy()
    UnmapViewOfFile p
    CloseHandle h
    h = hNull
    p = pNull
End Sub

Private Sub Class_Terminate()
    If h <> hNull Then Destroy
End Sub
''@E Destroy

