// SEIVE.H
//
// Definition of the Sieve prime number class
//

#ifndef __SIEVE_H__
#define __SIEVE_H__

#include "BaseDisp.h"
#ifdef WIN32
#include "sieve32.h"
#else
#include "sieve16.h"
#endif

CLASS CCSieve : public CBaseIDispatch
{
public:
	CCSieve(void);
	~CCSieve(void);

	static CCSieve FAR* Create(void);

	// Interface methods
	STDMETHOD(get_NextPrime)(THIS_ short * piRet);

	STDMETHOD(get_MaxPrime)(THIS_ short FAR * piRet);
	STDMETHOD(put_MaxPrime)(THIS_ short iMaxPrime);

	STDMETHOD(get_Primes)(THIS_ short FAR * piRet);

	STDMETHOD(get_Title)(THIS_ BSTR FAR * psRet);
	STDMETHOD(put_Title)(THIS_ BSTR s);

	STDMETHOD(ReInitialize)(THIS_ void);
	STDMETHOD(AllPrimes)(THIS_ LPSAFEARRAY * ppsa);

private:
	//$B PrivateMembers
	short * 		m_af;
	int 			m_iCur;
	short			m_iMaxPrime;
	short			m_cPrime;
	BSTR			m_sTitle;
	//$E PrivateMembers

	BOOL m_ThrowInvalidMax;
	BOOL m_ThrowInvalidArray;
	// Add more errors here
};

CLASS CCSieveCF : public IClassFactory
{
public:
	static IClassFactory FAR* Create();

	// IUnknown methods
	STDMETHOD(QueryInterface)(REFIID riid, void FAR* FAR* ppv);
	STDMETHOD_(ULONG, AddRef)(void);
	STDMETHOD_(ULONG, Release)(void);

	// IClassFactory methods
	STDMETHOD(CreateInstance)(IUnknown FAR* pUnkOuter, REFIID riid, void FAR* FAR* ppv);
	STDMETHOD(LockServer)(BOOL fLock);
	CCSieveCF();
	~CCSieveCF();
private:

	ULONG m_refs;
};

#endif // __SIEVE_H__
