VERSION 4.00
Begin VB.Form FSieveServer 
   Caption         =   "Sieve of Eratosthenes Server"
   ClientHeight    =   3255
   ClientLeft      =   1425
   ClientTop       =   1650
   ClientWidth     =   5055
   Height          =   3660
   Icon            =   "SIEVESRV.frx":0000
   Left            =   1365
   LinkTopic       =   "Form1"
   ScaleHeight     =   3255
   ScaleWidth      =   5055
   Top             =   1305
   Width           =   5175
   Begin VB.CheckBox chkAll 
      Caption         =   "Get All"
      Height          =   240
      Left            =   2880
      TabIndex        =   14
      Top             =   2880
      Width           =   975
   End
   Begin VB.CheckBox chkLate 
      Caption         =   "Late Bind"
      Height          =   255
      Left            =   2880
      TabIndex        =   13
      Top             =   2595
      Width           =   975
   End
   Begin VB.ListBox lstOutput 
      Height          =   2955
      Left            =   3885
      TabIndex        =   12
      Top             =   120
      Width           =   975
   End
   Begin VB.CheckBox chkFunction 
      Caption         =   "Function"
      Height          =   255
      Left            =   2880
      TabIndex        =   11
      Top             =   2325
      Width           =   975
   End
   Begin VB.TextBox txtTime 
      Height          =   375
      Left            =   2880
      TabIndex        =   9
      Top             =   1560
      Width           =   855
   End
   Begin VB.TextBox txtPrimes 
      Height          =   375
      Left            =   2880
      TabIndex        =   7
      Top             =   1080
      Width           =   855
   End
   Begin VB.CheckBox chkDisplay 
      Caption         =   "Display"
      Height          =   255
      Left            =   2880
      TabIndex        =   4
      Top             =   2040
      Width           =   975
   End
   Begin VB.TextBox txtMaxPrime 
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Text            =   " 5000"
      Top             =   600
      Width           =   855
   End
   Begin VB.TextBox txtIterate 
      Height          =   375
      Left            =   2880
      TabIndex        =   2
      Text            =   "10"
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdSieve 
      Caption         =   "&Sieve"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lbl 
      Caption         =   "Time:"
      Height          =   375
      Index           =   3
      Left            =   1560
      TabIndex        =   10
      Top             =   1560
      Width           =   1215
   End
   Begin VB.Label lbl 
      Caption         =   "Primes:"
      Height          =   375
      Index           =   2
      Left            =   1560
      TabIndex        =   8
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label lbl 
      Caption         =   "Maximum Prime:"
      Height          =   375
      Index           =   1
      Left            =   1560
      TabIndex        =   6
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label lbl 
      Caption         =   "Iterations:"
      Height          =   375
      Index           =   0
      Left            =   1560
      TabIndex        =   5
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "FSieveServer"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private fDisplay As Boolean
Private dx As Long, dxOut As Long

Private Sub chkDisplay_Click()
    Static cLastIter As Integer
    If cLastIter = 0 Then cLastIter = txtIterate.Text
    fDisplay = (chkDisplay.Value = vbChecked)
    If fDisplay Then
        txtIterate.Text = 1
        Width = dx
    Else
        txtIterate.Text = cLastIter
        Width = dxOut
    End If
End Sub

Private Sub chkFunction_Click()
    RefreshControls
    chkLate.Enabled = (chkFunction <> vbChecked)
    chkAll.Enabled = (chkFunction <> vbChecked)
End Sub

Private Sub cmdExit_Click()
    Unload Me
    End
End Sub

Private Sub cmdSieve_Click()
    Dim ordMouse As Integer, ms As Long, i As Integer, iPrime As Integer
    Dim iMaxPrime As Integer, cIter As Integer
    Dim ai() As Integer, cPrime As Integer
    ordMouse = Me.MousePointer
    
    Me.MousePointer = vbHourglass
    iMaxPrime = txtMaxPrime.Text
    cIter = txtIterate.Text
    txtTime.Text = sEmpty
    txtPrimes.Text = sEmpty
    RefreshControls
    cPrime = txtMaxPrime.Text
    ''@B CallSieve
    If chkFunction = vbChecked Then
        ' Functional version
        ms = timeGetTime()
        For i = 1 To cIter
            txtPrimes.Text = Sieve(iMaxPrime, fDisplay, lstOutput)
        Next
        txtTime.Text = timeGetTime() - ms
    ElseIf chkLate <> vbChecked Then
        ' Object-oriented version, early bind
        Dim siv As New CSieve
        If chkAll <> vbChecked Then
            ' Get one at a time
            siv.MaxPrime = txtMaxPrime.Text
            ms = timeGetTime()
            For i = 1 To cIter
                siv.ReInitialize
                Do
                    iPrime = siv.NextPrime
                    If fDisplay And iPrime Then
                        lstOutput.AddItem iPrime
                        lstOutput.TopIndex = lstOutput.ListCount - 1
                        lstOutput.Refresh
                    End If
                Loop Until iPrime = 0
            Next
            txtTime.Text = timeGetTime() - ms
            txtPrimes.Text = siv.Primes
        Else
            ' Get all at once
    ''@E CallSieve...
            ms = timeGetTime()
            For i = 1 To cIter
                ReDim ai(0 To cPrime)
                siv.AllPrimes ai()
                If fDisplay Then
                    For iPrime = 0 To siv.Primes - 1
                        lstOutput.AddItem ai(iPrime)
                    Next
                End If
            Next
            txtTime.Text = timeGetTime() - ms
            txtPrimes.Text = siv.Primes
        End If
    Else ' Late binding
        ' Object-oriented version, late bind
        ''@B OldCSieve
        Dim rsiv As Object
        Set rsiv = New CSieve
        rsiv.MaxPrime = txtMaxPrime.Text
        ''@E OldCSieve
        If chkAll <> vbChecked Then
            ' Get one at a time
            ms = timeGetTime()
            For i = 1 To cIter
                rsiv.ReInitialize
                Do
                    iPrime = rsiv.NextPrime
                    If fDisplay And iPrime Then
                        lstOutput.AddItem iPrime
                        lstOutput.TopIndex = lstOutput.ListCount - 1
                        lstOutput.Refresh
                    End If
                Loop Until iPrime = 0
            Next
            txtTime.Text = timeGetTime() - ms
            txtPrimes.Text = rsiv.Primes
        Else
            ' Get all at once
            ms = timeGetTime()
            For i = 1 To cIter
                ReDim ai(0 To cPrime)
                rsiv.AllPrimes ai()
                If fDisplay Then
                    For iPrime = 0 To rsiv.Primes - 1
                        lstOutput.AddItem ai(iPrime)
                    Next
                End If
            Next
            txtTime.Text = timeGetTime() - ms
            txtPrimes.Text = rsiv.Primes
        End If
    End If
    Me.MousePointer = ordMouse
End Sub

' Eratosthenes Sieve Prime Number Program based on C version in Byte,
' January 1983. The code has been corrected to produce primes correctly.
''@B Sieve
Function Sieve(iMaxPrime As Integer, fDisplay As Boolean, _
               lstOutput As ListBox) As Integer
    Dim iCur As Integer, i As Integer, s As String, cPrime As Integer
    Dim af() As Boolean
    ReDim af(0 To iMaxPrime + 1) As Boolean

    If fDisplay Then lstOutput.Clear
    For iCur = 2 To iMaxPrime
        If Not af(iCur) Then    ' Found a prime
            If fDisplay Then lstOutput.AddItem iCur
            For i = iCur + iCur To iMaxPrime Step iCur
                af(i) = True    ' Cancel its multiples
            Next
            cPrime = cPrime + 1
        End If
    Next
    Sieve = cPrime
End Function
''@E Sieve

Sub RefreshControls()
    If lstOutput.ListCount Then lstOutput.Clear
    txtTime.Text = sEmpty
    txtPrimes.Text = sEmpty
End Sub

Private Sub Form_Load()
    dxOut = lstOutput.Left + Width - ScaleWidth
    dx = Width
    Width = dxOut
    Show
End Sub

Private Sub txtIterate_Change()
    RefreshControls
End Sub
