Attribute VB_Name = "MTimeIt"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses DEBUG.BAS UTILITY.BAS SORT.BAS

Private n As Long
Private iVar As Integer
Public Const ordSortVal = 0
Public Const ordSortText = 1
Public Const ordSortBin = 2
Public Const ordSortLen = 3

''@B LongTypes
Private Type TLoHiLong
  lo As Integer
  hi As Integer
End Type

Private Type TAllLong
  all As Long
End Type
''@E LongTypes

#If Win32 Then
Private Declare Function LoWord5 Lib "VBUTIL32.DLL" Alias "LoWord" ( _
    ByVal dw As Long) As Integer
#Else
''@B LoWord5
Private Declare Function LoWord5 Lib "VBUTIL16.DLL" Alias "LoWord" ( _
    ByVal dw As Long) As Integer
''@E LoWord5
#End If

''@B LogicalAnd
Function LogicalAndVsNestedIf(cIter As Long) As String
    ''@B Profile1
    Dim ms As Long, msOut As Long
    ''@E Profile1
    Dim sMsg As String, i As Integer, iIter As Long

    i = 21
    ''@B Profile2
    ProfileStart ms
    ''@E Profile2
    For iIter = 1 To cIter
        ''@B If1
        If i <= 20 And i >= 10 Then i = i + 1
        ''@E If1
    Next
    ''@B Profile3
    ProfileStop ms, msOut
    ''@E Profile3
    sMsg = "If a And b Then: " & msOut & " ms" & sCrLf

    i = 21
    ProfileStart ms
    For iIter = 1 To cIter
        ''@B If2
        If i <= 20 Then If i >= 10 Then i = i + 1
        ''@E If2
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "If a Then If b Then: " & msOut & " ms" & sCrLf

    LogicalAndVsNestedIf = sMsg

End Function ''@E LogicalAnd

Function ByValVsByRef(cIter As Long) As String
    Dim ms As Long, msOut As Long
    Dim sMsg As String
    Dim i As Integer, d As Double, n As Long, s As String
    
    i = 5

    ProfileStart ms
    For n = 1 To cIter
        TestByValInt i
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Variable Integer by value: " & msOut & " ms" & sCrLf

    ProfileStart ms
    For n = 1 To cIter
        TestByRefInt i
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Variable Integer by reference: " & msOut & " ms" & sCrLf

    ProfileStart ms
    For n = 1 To cIter
        TestByValInt 5
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Constant Integer by value: " & msOut & " ms" & sCrLf
    
    ProfileStart ms
    For n = 1 To cIter
        TestByRefInt 5
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Constant Integer by reference: " & msOut & " ms" & sCrLf
    
    d = 2.1
    ProfileStart ms
    For n = 1 To cIter
        TestByValDbl d
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Variable Double by value: " & msOut & " ms" & sCrLf

    ProfileStart ms
    For n = 1 To cIter
        TestByRefDbl d
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Variable Double by reference: " & msOut & " ms" & sCrLf

    ProfileStart ms
    For n = 1 To cIter
        TestByValDbl 2.1
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Constant Double by value: " & msOut & " ms" & sCrLf
    
    ProfileStart ms
    For n = 1 To cIter
        TestByRefDbl 2.1
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Constant Double by reference: " & msOut & " ms" & sCrLf
    
    s = "Hardcore"
    ProfileStart ms
    For n = 1 To cIter
        TestByValStr s
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Variable String by value: " & msOut & " ms" & sCrLf

    ProfileStart ms
    For n = 1 To cIter
        TestByRefStr s
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Variable String by reference: " & msOut & " ms" & sCrLf

    ByValVsByRef = sMsg

End Function

Private Sub TestByValInt(ByVal iArg As Integer)
    Dim iVar As Integer
    iVar = iArg
End Sub

Private Sub TestByRefInt(iArg As Integer)
    Dim iVar As Integer
    iVar = iArg
End Sub

Private Sub TestByValDbl(ByVal rArg As Double)
    Dim rVar As Double
    rVar = rArg
End Sub

Private Sub TestByRefDbl(rArg As Double)
    Dim rVar As Double
    rVar = rArg
End Sub

Private Sub TestByValStr(ByVal sArg As String)
    Dim sVar As String
    sVar = sArg
End Sub

Private Sub TestByRefStr(sArg As String)
    Dim sVar As String
    sVar = sArg
End Sub

''@B time2
Function DimNestedLevels(cIter As Long) As String
    Dim ms As Long, msOut As Long
    Dim sMsg As String
    Dim i As Integer, n As Long
    
    i = 21

    ProfileStart ms
    For n = 1 To cIter
        If (i < 20) Then
            Dim iIn
            iIn = 20
        End If
    Next
    ProfileStop ms, msOut
    sMsg = "Inner Dim: " & msOut & " ms" & sCrLf

    ProfileStart ms
    Dim iOut
    For n = 1 To cIter
        If (i < 20) Then
            iOut = 20
        End If
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Outer Dim: " & msOut & " ms" & sCrLf

    ProfileStart ms
    For n = 1 To cIter
        Dim iMid
        If (i < 20) Then
            iMid = 20
        End If
    Next
    ProfileStop ms, msOut
    sMsg = sMsg & "Middle Dim: " & msOut & " ms" & sCrLf

    DimNestedLevels = sMsg

''@E time2
End Function

''@B TimeTypes
Function CompareTypeProcessing(cIter As Long) As String
    Dim ms As Long, msOut As Long
    Dim sMsg As String
    Dim i As Integer, v As Variant, l As Long
    Dim s As Single, d As Double, c As Currency
    Dim i2 As Integer, v2 As Variant, l2 As Long
    Dim s2 As Single, d2 As Double, c2 As Currency
    Dim ci As Integer, cv As Variant, cl As Long
    Dim cs As Single, cd As Double, cc As Currency
    ci = IIf(cIter < 32767&, cIter, 0)
    cv = cIter: cl = cIter: cs = cIter: cd = cIter: cc = cIter
    
    ProfileStart ms
    i = 1
    Do While i < ci
        i2 = 1
        Do While i2 < ci
            i2 = i2 + 1
        Loop
        i = i + 1
    Loop
    ProfileStop ms, msOut
    sMsg = "Integer: " & msOut & " ms" & sCrLf

    ProfileStart ms
    l = 1
    Do While l < cl
        l2 = 1
        Do While l2 < ci
            l2 = l2 + 1
        Loop
        l = l + 1
    Loop
    ProfileStop ms, msOut
    sMsg = sMsg & "Long: " & msOut & " ms" & sCrLf

    ProfileStart ms
    s = 1
    Do While s < cs
        s2 = 1
        Do While s2 < ci
            s2 = s2 + 1
        Loop
        s = s + 1
    Loop
    ProfileStop ms, msOut
    sMsg = sMsg & "Single: " & msOut & " ms" & sCrLf

    ProfileStart ms
    d = 1
    Do While d < cd
        d2 = 1
        Do While d2 < ci
            d2 = d2 + 1
        Loop
        d = d + 1
    Loop
    ProfileStop ms, msOut
    sMsg = sMsg & "Double: " & msOut & " ms" & sCrLf

    ProfileStart ms
    c = 1
    Do While c < cc
        c2 = 1
        Do While c2 < ci
            c2 = c2 + 1
        Loop
        c = c + 1
    Loop
    ProfileStop ms, msOut
    sMsg = sMsg & "Currency: " & msOut & " ms" & sCrLf

    ProfileStart ms
    v = 1
    Do While v < cv
        v2 = 1
        Do While v2 < ci
            v2 = v2 + 1
        Loop
        v = v + 1
    Loop
    ProfileStop ms, msOut
    sMsg = sMsg & "Variant: " & msOut & " ms" & sCrLf

    CompareTypeProcessing = sMsg

End Function ''@E TimeTypes

Function InlineVsFunction(cIter As Long) As String
    Dim ms As Long, msOut As Long
    Dim sMsg As String
    Dim i As Long, n As Long, d As Double

    i = 1
    ProfileStart ms
    
    For n = 1 To cIter
        i = i + 1
    Next

    ProfileStop ms, msOut
    sMsg = "Inline addition: " & msOut & " ms" & sCrLf

    i = 1
    ProfileStart ms
    For n = 1 To cIter
        i = AddEm(i, 5)
    Next

    ProfileStop ms, msOut
    sMsg = sMsg & "Function Addition: " & msOut & " ms" & sCrLf

    i = 1
    ProfileStart ms
    For n = 1 To cIter
        d = n ^ 5
    Next

    ProfileStop ms, msOut
    sMsg = sMsg & "Inline power: " & msOut & " ms" & sCrLf

    i = 1
    ProfileStart ms
    For n = 1 To cIter
        d = Power(n, 5)
    Next

    ProfileStop ms, msOut
    sMsg = sMsg & "Function power: " & msOut & " ms" & sCrLf

    InlineVsFunction = sMsg
                                    
End Function

Private Function AddEm(ByVal i1 As Long, i2 As Long) As Long
    AddEm = i1 + i2
End Function

Private Function Power(ByVal i1 As Long, i2 As Long) As Double
    Power = i1 ^ i2
End Function

Function CompareLoWords(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long
    Dim f16Wrap As Integer, f16NoWrap As Integer
    Dim f32Wrap As Long, f32NoWrap As Long
    f32NoWrap = &H12345678
    f32Wrap = &HFEDCBA98


    #If 0 Then
    ' This causes overflow -- try it
    f16Wrap = LoWord1(f32Wrap)
    #End If
    
    ProfileStart ti
    For i = 1 To cIter
        f16NoWrap = LoWord1(f32NoWrap)
    Next
    ProfileStop ti, tiOut
    sMsg = "LoWord1 - AND positive Long: " & tiOut & " ms" & sCrLf
    BugMessage "LoWord1 Wrap: " & Hex$(f16Wrap) & "  NoWrap: " & Hex$(f16NoWrap)

    ProfileStart ti
    For i = 1 To cIter
        f16NoWrap = LoWord2(f32NoWrap)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "LoWord2 - AND positive Long after sign check: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        f16Wrap = LoWord2(f32Wrap)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "LoWord2 - AND negative Long after sign check: " & tiOut & " ms" & sCrLf
    BugMessage "LoWord2 Wrap: " & Hex$(f16Wrap) & "  NoWrap: " & Hex$(f16NoWrap)

    f16NoWrap = LoWord3(f32Wrap)
    ProfileStart ti
    For i = 1 To cIter
        f16NoWrap = LoWord3(f32NoWrap)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "LoWord3 - Copy low word with LSet: " & tiOut & " ms" & sCrLf
    BugMessage "LoWord3 Wrap: " & Hex$(f16Wrap) & "  NoWrap: " & Hex$(f16NoWrap)

    f16Wrap = LoWord4(f32Wrap)
    ProfileStart ti
    For i = 1 To cIter
        f16NoWrap = LoWord4(f32NoWrap)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "LoWord4 - Copy low word with CopyMemory: " & tiOut & " ms" & sCrLf
    BugMessage "LoWord4 Wrap: " & Hex$(f16Wrap) & "  NoWrap: " & Hex$(f16NoWrap)
    
    f16Wrap = LoWord5(f32Wrap)
    ProfileStart ti
    For i = 1 To cIter
        f16NoWrap = LoWord5(f32NoWrap)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "LoWord5 - AND unsigned long in C DLL: " & tiOut & " ms" & sCrLf
    BugMessage "LoWord5 Wrap: " & Hex$(f16Wrap) & "  NoWrap: " & Hex$(f16NoWrap)

    CompareLoWords = sMsg

End Function

''@B LoWord1
Private Function LoWord1(dw As Long) As Integer
    LoWord1 = dw And &HFFFF&
End Function ''@E LoWord1

''@B LoWord2
Private Function LoWord2(dw As Long) As Integer
    If (dw And &H8000&) = 0 Then
        LoWord2 = dw And &HFFFF&
    Else
        LoWord2 = &H8000 Or (dw And &H7FFF&)
    End If
End Function ''@E LoWord2

''@B LoWord3
Private Function LoWord3(dw As Long) As Integer
    Static lohi As TLoHiLong
    Static all  As TAllLong
    all.all = dw
    LSet lohi = all
    LoWord3 = lohi.lo
End Function ''@E LoWord3

''@B LoWord4
Private Function LoWord4(dw As Long) As Integer
    Static w As Integer
    CopyMemory w, dw, 2
    LoWord4 = w
End Function ''@E LoWord4

Function CShiftVsBShift(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long, iVal As Integer

    If cIter > 16364 Then
        sMsg = "Count " & cIter & " too large; "
        cIter = 16364
        sMsg = sMsg & "using " & cIter
        MsgBox sMsg
    End If
    ProfileStart ti
    For i = 1 To cIter
        iVal = i * 2
    Next
    ProfileStop ti, tiOut
    sMsg = "Multiply by two: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        iVal = LShiftWord(i, 1)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "C Shift left one: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        iVal = LShiftWordB(i, 1)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Basic Shift left one: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iVal = i / 2
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Divide by two: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        iVal = RShiftWord(i, 1)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "C shift right one: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        iVal = RShiftWordB(i, 1)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Basic shift right one: " & tiOut & " ms" & sCrLf

    CShiftVsBShift = sMsg
    
End Function

Function LShiftWordB(ByVal w As Integer, ByVal c As Integer) As Integer
    Dim dw As Long
    dw = w * (2 ^ c)
    If dw And &H8000& Then
        LShiftWordB = CInt(dw And &H7FFF&) Or &H8000
    Else
        LShiftWordB = dw And &HFFFF&
    End If
End Function

Function RShiftWordB(ByVal w As Integer, ByVal c As Integer) As Integer
    Dim dw As Long
    If c = 0 Then
        RShiftWordB = w
    Else
        dw = w And &HFFFF&
        dw = dw \ (2 ^ c)
        RShiftWordB = dw And &HFFFF&
    End If
End Function

Function IIfVsIfThen(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long, iRes As Integer
    Dim ix As Integer, iy As Integer
    ix = 40: iy = 50
    
    ProfileStart ti
    For i = 1 To cIter
        iRes = IIf(ix > iy, ix, iy)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "IIf: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        If ix > iy Then
            iRes = ix
        Else
            iRes = iy
        End If
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "If-Then-Else: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iRes = MyIIf(ix > iy, ix, iy)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "MyIIf (Variant): " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iRes = MyIIfInt(ix > iy, ix, iy)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "MyIIfInt: " & tiOut & " ms" & sCrLf

    IIfVsIfThen = sMsg

End Function

Private Function MyIIf(vCondition As Variant, vTrue As Variant, vFalse As Variant) As Variant
    If vCondition Then
        MyIIf = vTrue
    Else
        MyIIf = vFalse
    End If
End Function

Private Function MyIIfInt(iCondition As Integer, iTrue As Integer, iFalse As Integer) As Integer
    If iCondition Then
        MyIIfInt = iTrue
    Else
        MyIIfInt = iFalse
    End If
End Function

Function DollarVsNone(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long, iPos As Integer, cInput As Integer
    Const sTest As String = "To VB or not to VB, that is the question..."
    cInput = Len(sTest)
    Dim sOut As String, vOut As Variant
    Dim sInput As String, vInput As Variant

    sInput = sTest
    ProfileStart ti
    For i = 1 To cIter
        For iPos = 1 To Len(sInput) - 1
            sOut = Mid$(sInput, iPos)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "s = Mid$(s, i): " & tiOut & " ms" & sCrLf

    vInput = sTest
    ProfileStart ti
    For i = 1 To cIter
        For iPos = 1 To Len(sInput) - 1
            sOut = Mid$(vInput, iPos)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "s = Mid$(v, i): " & tiOut & " ms" & sCrLf

    vInput = sTest
    ProfileStart ti
    For i = 1 To cIter
        For iPos = 1 To Len(sInput) - 1
            vOut = Mid$(vInput, iPos)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "v = Mid$(v, i): " & tiOut & " ms" & sCrLf
    
    sInput = sTest
    ProfileStart ti
    For i = 1 To cIter
        For iPos = 1 To Len(sInput) - 1
            vOut = Mid$(sInput, iPos)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "v = Mid$(s, i): " & tiOut & " ms" & sCrLf
    
    sInput = sTest
    ProfileStart ti
    For i = 1 To cIter
        For iPos = 1 To Len(sInput) - 1
            sOut = Mid(sInput, iPos)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "s = Mid(s, i): " & tiOut & " ms" & sCrLf

    vInput = sTest
    ProfileStart ti
    For i = 1 To cIter
        For iPos = 1 To Len(sInput) - 1
            sOut = Mid(vInput, iPos)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "s = Mid(v, i): " & tiOut & " ms" & sCrLf

    vInput = sTest
    ProfileStart ti
    For i = 1 To cIter
        For iPos = 1 To Len(sInput) - 1
            vOut = Mid(vInput, iPos)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "v = Mid(v, i): " & tiOut & " ms" & sCrLf
    
    sInput = sTest
    ProfileStart ti
    For i = 1 To cIter
        For iPos = 1 To Len(sInput) - 1
            vOut = Mid(sInput, iPos)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "v = Mid(s, i): " & tiOut & " ms" & sCrLf
    
    DollarVsNone = sMsg

End Function

Function EmptyVsQuotes(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim asTest(0 To 1) As String
    Dim f As Boolean, i As Long
    
    asTest(0) = "Test"
    asTest(1) = Empty
    
    ProfileStart ti
    For i = 1 To cIter
        f = (asTest(i Mod 2) = sEmpty)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "s = sEmpty (String constant): " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        f = (asTest(i Mod 2) = "")
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "s = """" (inline quotes): " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        f = (asTest(i Mod 2) = Empty)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "s = Empty (Variant constant): " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        f = (asTest(i Mod 2) = vbNullString)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "s = vbNullString (null pointer constant): " & tiOut & " ms" & sCrLf

    EmptyVsQuotes = sMsg

End Function

Function WithWithout(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long, iTest As Integer
    Dim nc As New CNull, rnc As CNull
    Set rnc = nc
    
    ProfileStart ti
    For i = 1 To cIter
        rnc.ProcProp = 5
        iTest = rnc.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Reference qualified access, one read/write: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        With rnc
            .ProcProp = 5
            iTest = .ProcProp
        End With
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Reference With access, one read/write: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        rnc.ProcProp = 5
        iTest = rnc.ProcProp
        rnc.ProcProp = 6
        iTest = rnc.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Reference qualified access, two read/write: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        With rnc
            .ProcProp = 5
            iTest = .ProcProp
            .ProcProp = 6
            iTest = .ProcProp
        End With
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Reference With access, two read/write: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        rnc.ProcProp = 5
        iTest = rnc.ProcProp
        rnc.ProcProp = 6
        iTest = rnc.ProcProp
        rnc.ProcProp = 7
        iTest = rnc.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Reference qualified access, three read/write: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        With rnc
            .ProcProp = 5
            iTest = .ProcProp
            .ProcProp = 6
            iTest = .ProcProp
            .ProcProp = 7
            iTest = .ProcProp
        End With
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Reference With access, three read/write: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        rnc.ProcProp = 5
        iTest = rnc.ProcProp
        rnc.ProcProp = 6
        iTest = rnc.ProcProp
        rnc.ProcProp = 7
        iTest = rnc.ProcProp
        rnc.ProcProp = 8
        iTest = rnc.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Reference qualified access, four read/write: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        With rnc
            .ProcProp = 5
            iTest = .ProcProp
            .ProcProp = 6
            iTest = .ProcProp
            .ProcProp = 7
            iTest = .ProcProp
            .ProcProp = 8
            iTest = .ProcProp
        End With
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Reference With access, four read/write: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        nc.ProcProp = 5
        iTest = nc.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Direct qualified access, one read/write: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        With nc
            .ProcProp = 5
            iTest = .ProcProp
        End With
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Direct With access, one read/write: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        nc.ProcProp = 5
        iTest = nc.ProcProp
        nc.ProcProp = 6
        iTest = nc.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Direct qualified access, two read/write: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        With nc
            .ProcProp = 5
            iTest = .ProcProp
            .ProcProp = 6
            iTest = .ProcProp
        End With
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Direct With access, two read/write: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        nc.ProcProp = 5
        iTest = nc.ProcProp
        nc.ProcProp = 6
        iTest = nc.ProcProp
        nc.ProcProp = 7
        iTest = nc.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Direct qualified access, three read/write: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        With nc
            .ProcProp = 5
            iTest = .ProcProp
            .ProcProp = 6
            iTest = .ProcProp
            .ProcProp = 7
            iTest = .ProcProp
        End With
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Direct With access, three read/write: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        nc.ProcProp = 5
        iTest = nc.ProcProp
        nc.ProcProp = 6
        iTest = nc.ProcProp
        nc.ProcProp = 7
        iTest = nc.ProcProp
        nc.ProcProp = 8
        iTest = nc.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Direct qualified access, four read/write: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        With nc
            .ProcProp = 5
            iTest = .ProcProp
            .ProcProp = 6
            iTest = .ProcProp
            .ProcProp = 7
            iTest = .ProcProp
            .ProcProp = 8
            iTest = .ProcProp
        End With
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Direct With access, four read/write: " & tiOut & " ms" & sCrLf
    
    WithWithout = sMsg

End Function

Function ObjectVsProc(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long
    Dim iTest As Integer
    Dim nul As New CNull, rnul As CNull
    Set rnul = nul
    
    ProfileStart ti
    For i = 1 To cIter
        iTest = nul.FuncMethod()
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Call method function on object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iTest = rnul.FuncMethod()
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Call method function on reference object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iTest = FuncProc()
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Call private function: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        nul.SubMethod iTest
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Pass variable to method sub on object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        rnul.SubMethod iTest
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Pass variable to method sub on reference object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iTest = FuncProc()
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Pass variable to private sub: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        nul.ProcProp = 5
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign through property let on object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        rnul.ProcProp = 5
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign through property let on reference object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        PrivProp = 5
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign through private property let: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        iTest = nul.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign from property get on object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iTest = rnul.ProcProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign from property get on reference object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iTest = PrivProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign from private property get: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        nul.PubProp = 5
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign to public property on object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        rnul.PubProp = 5
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign to public property on reference object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iVar = 5
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign to private variable: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        iTest = nul.PubProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign from public property on object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iTest = rnul.PubProp
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign from public property on reference object: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        iTest = iVar
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Assign from private variable: " & tiOut & " ms" & sCrLf
    
    ObjectVsProc = sMsg

End Function

Private Sub SubProc(i As Integer)
    i = 1
End Sub

Private Function FuncProc()
    FuncProc = 2
End Function

Private Property Let PrivProp(i As Integer)
    iVar = i
End Property

Private Property Get PrivProp() As Integer
    PrivProp = iVar
End Property

Function PlusVsAmpersand(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long
    Dim s As String
    
    ProfileStart ti
    For i = 1 To cIter
        s = "One " & "Two " & "Three " & "Four " & "Five " & _
            "Six " & "Seven " & "Eight " & "Nine " & "Ten"
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Concat with ampersand: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        s = "One " + "Two " + "Three " + "Four " + "Five " & _
            "Six " + "Seven " + "Eight " + "Nine " + "Ten"
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Concat with plus: " & tiOut & " ms" & sCrLf

    PlusVsAmpersand = sMsg

End Function

Function ForEachVsForI(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long
    Dim iTemp As Integer, s As String, v As Variant, ix As Integer
    Dim rnc As CNull
    Dim nNulls As New Collection
    Dim aNulls(1 To 50) As CNull
    Dim aNullStrs(1 To 50) As String
    Dim aNullInts(1 To 50) As Integer
    
    ' Create a collection and an array of 50 Integers
    For iTemp = 1 To 50
        nNulls.Add iTemp
        aNullInts(iTemp) = iTemp
    Next
    
    ProfileStart ti
    For i = 1 To cIter
        For iTemp = 1 To 50
            ix = aNullInts(iTemp)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For I on Integer array: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        For Each v In aNullInts
            ix = v
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For Each on Integer array: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        For Each v In nNulls
            ix = v
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For Each on Integer collection: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        For iTemp = 1 To nNulls.Count
            ix = nNulls(iTemp)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For I on Integer collection: " & tiOut & " ms" & sCrLf
    
    ' Create a collection and an array of 50 strings
    Set nNulls = Nothing
    For iTemp = 1 To 50
        nNulls.Add "Item" & iTemp
        aNullStrs(iTemp) = "Item" & iTemp
    Next
    
    ProfileStart ti
    For i = 1 To cIter
        For iTemp = 1 To 50
            s = aNullStrs(iTemp)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For I on String array: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        For Each v In aNullStrs
            s = v
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For Each on String array: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        For Each v In nNulls
            s = v
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For Each on String collection: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        For iTemp = 1 To nNulls.Count
            s = nNulls(iTemp)
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For I on String collection: " & tiOut & " ms" & sCrLf
    
    ' Create a collection and an array of 50 objects
    Set nNulls = Nothing
    For iTemp = 1 To 50
        Set rnc = New CNull
        nNulls.Add rnc
        Set aNulls(iTemp) = rnc
    Next
    
    ProfileStart ti
    For i = 1 To cIter
        For iTemp = 1 To 50
            ix = aNulls(iTemp).ProcProp
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For I on Object array: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        For Each v In aNulls
            ix = v.ProcProp
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For Each on Object array: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To cIter
        For Each rnc In nNulls
            ix = rnc.ProcProp
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For Each on Object collection: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = 1 To cIter
        For iTemp = 1 To nNulls.Count
            ix = nNulls(iTemp).ProcProp
        Next
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "For I on Object collection: " & tiOut & " ms" & sCrLf
    
    ForEachVsForI = sMsg

End Function

Function SortCollectVsArray(cIter As Long) As String
' Uncomment to step through and verify that everything works
'#Const fTestSorts = 1
#If fTestSorts Then
    cIter = 10
#End If
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long, iTemp As Long, c As Integer
    Dim a() As Variant
    Dim n As New Collection
    c = cIter
    ReDim a(1 To cIter) As Variant

    ProfileStart ti
    For i = 1 To c
        a(i) = i
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Fill array: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    For i = 1 To c
        n.Add i
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Fill collection: " & tiOut & " ms" & sCrLf
    ShowNA a(), n

    ProfileStart ti
    ShuffleArray a()
    ProfileStop ti, tiOut
    sMsg = sMsg & "Shuffle array: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    ShuffleCollection n
    ProfileStop ti, tiOut
    sMsg = sMsg & "Shuffle collection: " & tiOut & " ms" & sCrLf
    ShowNA a(), n

    ProfileStart ti
    SortArray a(), 1, CInt(c)
    ProfileStop ti, tiOut
    sMsg = sMsg & "Sort array: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    SortCollection n, 1, CInt(c)
    ProfileStop ti, tiOut
    sMsg = sMsg & "Sort collection: " & tiOut & " ms" & sCrLf
    ShowNA a(), n

    Dim v As Variant, iPos As Integer, f As Boolean
    v = GetRandom(1, c)
    ProfileStart ti
    For i = 1 To 50
        f = BSearchArray(a(), v, iPos)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Search array 50 Times: " & tiOut & " ms" & sCrLf
#If fTestSorts Then
    BugMessage "Array element " & v & IIf(f, sEmpty, "not ") & " found at " & iPos
#End If

    ProfileStart ti
    For i = 1 To 50
        f = BSearchCollection(n, v, iPos)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Search collection 50 Times: " & tiOut & " ms" & sCrLf
#If fTestSorts Then
    BugMessage "Collection element " & v & IIf(f, sEmpty, "not ") & " found at " & iPos
#End If

    SortCollectVsArray = sMsg

End Function

#If fTestSorts Then
Sub ShowNA(a() As Variant, n As Collection)
    Dim s As String, i As Integer, v As Variant
    For i = LBound(a) To UBound(a)
        s = s & a(i) & " "
    Next
    BugMessage "Array: " & s & sCrLf
    s = sEmpty
    For Each v In n
        s = s & v & " "
    Next
    BugMessage "Collection: " & s & sCrLf
End Sub
#Else
Sub ShowNA(a() As Variant, n As Collection)
End Sub
#End If

Function AddCollect(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String
    Dim i As Long, iTemp As Long, cHalf As Long
    Dim n As Collection
    cHalf = cIter / 2
    
    Set n = New Collection
    ProfileStart ti
    For i = 1 To cHalf
        n.Add i
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Add first half to end of collection: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = cHalf + 1 To cIter
        n.Add i
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Add last half to end of collection: " & tiOut & " ms" & sCrLf
    Set n = Nothing

    Set n = New Collection
    ProfileStart ti
    n.Add 1
    For i = 2 To cHalf
        n.Add i, , 1
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Add first half to start of collection: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = cHalf + 1 To cIter
        n.Add i, , 1
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Add last half to start of collection: " & tiOut & " ms" & sCrLf
    Set n = Nothing

    Set n = New Collection
    ProfileStart ti
    n.Add 1
    For i = 2 To cHalf
        n.Add i, , i \ 2
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Add first half to middle of collection: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    For i = cHalf + 1 To cIter
        n.Add i, , i \ 2
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Add last half to middle of collection: " & tiOut & " ms" & sCrLf
    Set n = Nothing

    AddCollect = sMsg

End Function

Function SortNameVsSortPoly(cIter As Long) As String
    Dim ti As Long, tiOut As Long
    Dim sMsg As String, v As Variant
    Dim i As Long, iTemp As Long, c As Integer
    Dim aN() As Variant, aP() As Variant
    Dim helper As New CSortHelper
    
    c = cIter
    ReDim aN(1 To cIter) As Variant
    ReDim aP(1 To cIter) As Variant
    ordMode = ordSortVal

    ' Fill both arrays
    For i = 1 To c
        aN(i) = i
        aP(i) = i
    Next
    
    ' Use same random sequence for both
    Rnd -1
    ProfileStart ti
    ShuffleArray aN()
    ProfileStop ti, tiOut
    sMsg = sMsg & "Shuffle with name-space hack: " & tiOut & " ms" & sCrLf

    Rnd -1
    ProfileStart ti
    PShuffleArray aP(), helper
    ProfileStop ti, tiOut
    sMsg = sMsg & "Shuffle with polymorphism hack: " & tiOut & " ms" & sCrLf
    
    ProfileStart ti
    SortArray aN(), 1, CInt(c)
    ProfileStop ti, tiOut
    sMsg = sMsg & "Sort with name-space hack: " & tiOut & " ms" & sCrLf

    ProfileStart ti
    PSortArray aP(), helper, 1, CInt(c)
    ProfileStop ti, tiOut
    sMsg = sMsg & "Sort with polymorphic hack: " & tiOut & " ms" & sCrLf
    
    Dim iPos As Integer, f As Boolean
    v = GetRandom(1, c)
    ProfileStart ti
    For i = 1 To 50
        f = BSearchArray(aN(), v, iPos)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Search 50 times with name-space hack: " & tiOut & " ms" & sCrLf

    v = GetRandom(1, c)
    ProfileStart ti
    For i = 1 To 50
        f = PBSearchArray(aP(), helper, v, iPos)
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Search 50 times with polymorphic hack: " & tiOut & " ms" & sCrLf
    
    SortNameVsSortPoly = sMsg
    
End Function

Function CompareFindFiles(cIter As Long) As String
    Dim ti As Long, tiOut As Long, i As Long
    Dim sMsg As String, v As Variant
    Dim vnFiles As Variant, vFile As Variant
    Const sFind = "command.com"
    
    Set vnFiles = Nothing
    ProfileStart ti
    For i = 1 To cIter
        Set vnFiles = FindFilesDir(sFind, "C:\")
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & "Find files with Dir$: " & Int(tiOut / 1000) & " sec" & sCrLf
    For Each vFile In vnFiles
        BugMessage vFile & sCrLf
    Next
    
#If Win32 Then
    Set vnFiles = Nothing
    ProfileStart ti
    For i = 1 To cIter
        Set vnFiles = FindFiles(sFind, "C:\")
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & sCrLf & "Find files with FindFirstFile: " & Int(tiOut / 1000) & " sec" & sCrLf
    For Each vFile In vnFiles
        BugMessage vFile & sCrLf
    Next
#Else
    sMsg = sMsg & sCrLf & "Find files with FindFirstFile: NA" & sCrLf
#End If
    Dim sCmd As String, hProg ' As SysInt
    sCmd = Environ$("COMSPEC") & " /c dir /s /b " & "C:\" & sFind & " > find.tmp"
    ProfileStart ti
    For i = 1 To cIter
        hProg = Shell(sCmd)
        Do While IsRunning(hProg)
            DoEvents
        Loop
    Next
    ProfileStop ti, tiOut
    sMsg = sMsg & sCrLf & "Find files with dir /s: " & Int(tiOut / 1000) & " sec" & sCrLf
    BugMessage GetFileText("find.tmp")
    Kill "find.tmp"
    
    CompareFindFiles = sMsg
    
End Function

