VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CVersion"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses UTILITY.BAS DEBUG.BAS

Private Type TFixedFileInfo
    dwSignature As Long            ' Must be &HFEEF04BD
    dwStrucVersion As Long         ' e.g. &H00000042 = "0.42"
    dwFileVersionMS As Long        ' e.g. &H00030075 = "3.75"
    dwFileVersionLS As Long        ' e.g. &H00000031 = "0.31"
    dwProductVersionMS As Long     ' e.g. &H00030010 = "3.10"
    dwProductVersionLS As Long     ' e.g. &H00000031 = "0.31"
    dwFileFlagsMask As Long        ' e.g. &H0000003F = "0.42"
    dwFileFlags As Long            ' e.g. VFF_DEBUG Or VFF_PRERELEASE
    dwFileOS As Long               ' e.g. VOS_DOS_WINDOWS16
    dwFileType As Long             ' e.g. VFT_DRIVER
    dwFileSubtype As Long          ' e.g. VFT2_DRV_KEYBOARD
    dwFileDateMS As Long
    dwFileDateLS As Long
End Type

' VS_VERSION.dwFileFlags
Const VS_FFI_SIGNATURE = &HFEEF04BD
Const VS_FFI_STRUCVERSION = &H10000
Const VS_FFI_FILEFLAGSMASK = &H3F

' VS_VERSION.dwFileFlags
Const VS_FF_DEBUG = &H1
Const VS_FF_PRERELEASE = &H2
Const VS_FF_PATCHED = &H4
Const VS_FF_PRIVATEBUILD = &H8
Const VS_FF_INFOINFERRED = &H10
Const VS_FF_SPECIALBUILD = &H20

' VS_VERSION.dwFileOS
Const VOS_UNKNOWN = &H0
Const VOS_DOS = &H10000
Const VOS_OS216 = &H20000
Const VOS_OS232 = &H30000
Const VOS_NT = &H40000

Const VOS__BASE = &H0
Const VOS__WINDOWS16 = &H1
Const VOS__PM16 = &H2
Const VOS__PM32 = &H3
Const VOS__WINDOWS32 = &H4

Const VOS_DOS_WINDOWS16 = &H10001
Const VOS_DOS_WINDOWS32 = &H10004
Const VOS_OS216_PM16 = &H20002
Const VOS_OS232_PM32 = &H30003
Const VOS_NT_WINDOWS32 = &H40004

' VS_VERSION.dwFileType
Const VFT_UNKNOWN = &H0
Const VFT_APP = &H1
Const VFT_DLL = &H2
Const VFT_DRV = &H3
Const VFT_FONT = &H4
Const VFT_VXD = &H5
Const VFT_STATIC_LIB = &H7

' VS_VERSION.dwFileSubtype for VFT_WINDOWS_DRV
Const VFT2_UNKNOWN = &H0
Const VFT2_DRV_PRINTER = &H1
Const VFT2_DRV_KEYBOARD = &H2
Const VFT2_DRV_LANGUAGE = &H3
Const VFT2_DRV_DISPLAY = &H4
Const VFT2_DRV_MOUSE = &H5
Const VFT2_DRV_NETWORK = &H6
Const VFT2_DRV_System = &H7
Const VFT2_DRV_INSTALLABLE = &H8
Const VFT2_DRV_SOUND = &H9
Const VFT2_DRV_COMM = &HA

' VS_VERSION.dwFileSubtype for VFT_WINDOWS_FONT
Const VFT2_FONT_RASTER = &H1
Const VFT2_FONT_VECTOR = &H2
Const VFT2_FONT_TRUETYPE = &H3

' VerFindFile() flags
Const VFFF_ISSHAREDFILE = &H1

Const VFF_CURNEDEST = &H1
Const VFF_FILEINUSE = &H2
Const VFF_BUFFTOOSMALL = &H4

' VerInstallFile() flags
Const VIFF_FORCEINSTALL = &H1
Const VIFF_DONTDELETEOLD = &H2

Const VIF_TEMPFILE = &H1
Const VIF_MISMATCH = &H2
Const VIF_SRCOLD = &H4

Const VIF_DIFFLANG = &H8
Const VIF_DIFFCODEPG = &H10
Const VIF_DIFFTYPE = &H20

Const VIF_WRITEPROT = &H40
Const VIF_FILEINUSE = &H80
Const VIF_OUTOFSPACE = &H100
Const VIF_ACCESSVIOLATION = &H200
Const VIF_SHARINGVIOLATION = &H400
Const VIF_CANNOTCREATE = &H800
Const VIF_CANNOTDELETE = &H1000
Const VIF_CANNOTRENAME = &H2000
Const VIF_CANNOTDELETECUR = &H4000
Const VIF_OUTOFMEMORY = &H8000

Const VIF_CANNOTREADSRC = &H10000
Const VIF_CANNOTREADDST = &H20000

Const VIF_BUFFTOOSMALL = &H40000

#If Win32 Then
Private Declare Function VerFindFile Lib "Version" Alias "VerFindFileA" ( _
        ByVal uFlags As Long, ByVal szFileName As String, _
        ByVal szWinDir As String, ByVal szAppDir As String, _
        ByVal szCurDir As String, lpuCurDirLen As Long, _
        ByVal szDestDir As String, lpuDestDirLen As Long) As Long

Private Declare Function VerInstallFile Lib "Version" _
        Alias "VerInstallFileA" (ByVal uFlags As Long, _
        ByVal szSrcFileName As String, ByVal szDestFileName As String, _
        ByVal szSrcDir As String, ByVal szDestDir As String, _
        ByVal szCurDir As String, ByVal szTmpFile As String, _
        lpuTmpFileLen As Long) As Long

Private Declare Function VerLanguageName Lib "Version" _
        Alias "VerLanguageNameA" (ByVal wLang As Long, _
        ByVal szLang As String, ByVal nSize As Long) As Long

Private Declare Function GetFileVersionInfoSize Lib "Version" _
        Alias "GetFileVersionInfoSizeA" (ByVal lpszFile As String, _
        lpdwHandle As Long) As Long

Private Declare Function GetFileVersionInfo Lib "Version" _
        Alias "GetFileVersionInfoA" (ByVal lpszFile As String, _
        ByVal dwHandle As Long, ByVal cbBuf As Long, _
        ByVal lpvData As String) As Long

Private Declare Function VerQueryValue Lib "Version" _
        Alias "VerQueryValueA" (ByVal lpvBlock As String, _
        ByVal lpszSubBlock As String, lplpBuffer As Long, _
        lpcb As Long) As Long

' Returns size of resource in bytes
Private Declare Function GetFileResourceSize Lib "Version" _
        Alias "GetFileResourceSizeA" (ByVal lpstrFilename As String, _
        ByVal lpstrResType As String, ByVal lpstrResID As String, _
        lpdwFileOffset As Long) As Long

' Reads file resource into buffer
Private Declare Function GetFileResource Lib "Version" _
        Alias "GetFileResourceSizeA" (ByVal lpstrFilename As String, _
        ByVal lpstrResType As String, ByVal lpstrResID As String, _
        ByVal dwFileOffset As Long, ByVal dwResLen As Long, _
        lpData As String) As Long

#Else

Private Declare Function VerFindFile Lib "VER.DLL" ( _
        ByVal uFlags As Integer, ByVal szFileName As String, _
        ByVal szWinDir As String, ByVal szAppDir As String, _
        ByVal szCurDir As String, lpuCurDirLen As Integer, _
        ByVal szDestDir As String, lpuDestDirLen As Integer) As Integer

Private Declare Function VerInstallFile Lib "VER.DLL" ( _
        ByVal uFlags As Integer, ByVal szSrcFileName As String, _
        ByVal szDestFileName As String, ByVal szSrcDir As String, _
        ByVal szDestDir As String, ByVal szCurDir As String, _
        ByVal szTmpFile As String, lpuTmpFileLen As Integer) As Long

Private Declare Function VerLanguageName Lib "VER.DLL" ( _
        ByVal wLang As Integer, ByVal szLang As String, _
        ByVal nSize As Integer) As Integer

Private Declare Function GetFileVersionInfoSize Lib "VER.DLL" ( _
    ByVal lpszFile As String, lpdwHandle As Long) As Long

Private Declare Function GetFileVersionInfo Lib "VER.DLL" ( _
        ByVal lpszFile As String, ByVal dwHandle As Long, _
        ByVal cbBuf As Long, ByVal lpvData As String) As Integer

Private Declare Function VerQueryValue Lib "VER.DLL" ( _
        ByVal lpvBlock As String, ByVal lpszSubBlock As String, _
        lplpBuffer As Long, lpcb As Integer) As Integer

' Returns size of resource in bytes
Private Declare Function GetFileResourceSize Lib "VER.DLL" ( _
        ByVal lpstrFilename As String, ByVal lpstrResType As String, _
        ByVal lpstrResID As String, lpdwFileOffset As Long) As Long

' Reads file resource into buffer
Private Declare Function GetFileResource Lib "VER.DLL" ( _
        ByVal lpstrFilename As String, ByVal lpstrResType As String, _
        ByVal lpstrResID As String, ByVal dwFileOffset As Long, _
        ByVal dwResLen As Long, lpData As String) As Integer

#End If

' Internal class data
Private sExeName As String
Private sVer As String, hVer As Long
Private cVer As Long, cVer2 As Long ' cVer2 for alignment (not used)
Private pData As Long
Private cData ' As SysInt
Private fixed As TFixedFileInfo
Private sPrefix As String

Private Sub ReInit()
    sExeName = sEmpty
    sVer = sEmpty
    fixed.dwSignature = 0&
    fixed.dwStrucVersion = 0&
    fixed.dwFileVersionMS = 0&
    fixed.dwFileVersionLS = 0&
    fixed.dwProductVersionMS = 0&
    fixed.dwProductVersionLS = 0&
    fixed.dwFileFlagsMask = 0&
    fixed.dwFileFlags = 0&
    fixed.dwFileOS = 0&
    fixed.dwFileType = 0&
    fixed.dwFileSubtype = 0&
    fixed.dwFileDateMS = 0&
    fixed.dwFileDateLS = 0&
End Sub

Private Function BufToStr(pBuf As Long, cBuf) As String
    Dim s As String
    s = String$(cBuf + 1, 0)
    CopyMemoryLpToStr s, pBuf, cBuf
    BufToStr = StrZToStr(s)
End Function

' Create new Version object
Function Create(sExeNameA As String) As Boolean

    ' Assume worst
    Create = False
    ' If it already exists, destroy it
    If sVer <> sEmpty Then ReInit

    ' Get size and handle of version data
    cVer = GetFileVersionInfoSize(sExeNameA, hVer)
    If cVer = 0 Then Exit Function
    sVer = String$(cVer, 0)
    If GetFileVersionInfo(sExeNameA, hVer, cVer, sVer) = False Then
        ReInit
        Exit Function
    End If

    ' Get fixed portion of data
    If VerQueryValue(sVer, "\", pData, cData) = False Then Exit Function
    BugAssert cData = Len(fixed)
    CopyMemory fixed, ByVal pData, Len(fixed)

    ' Get version as hex number with low and high reversed
    If VerQueryValue(sVer, "\VarFileInfo\Translation", pData, cData) = False _
            Or cData = 0 Then
        ReInit
        Exit Function
    End If

    ' Success - copy internal data to prefix and exe name
    CopyMemory cVer, ByVal pData, cData
    ' Version APIs are extremely picky about format of this string
    sPrefix = "\StringFileInfo\" & _
        FmtHex(LoWord(cVer), 4) & FmtHex(HiWord(cVer), 4) & "\"
    sExeName = sExeNameA
    Create = True
    
End Function

' Change file associated with an existing version object
Property Let ExeName(sExeNameA As String)
    ReInit
    Call Create(sExeNameA)
End Property

Property Get ExeName() As String
    ExeName = sExeName
End Property

Property Get FullFileVersion() As String
    If sVer = sEmpty Then
        FullFileVersion = sEmpty
    Else
        FullFileVersion = HiWord(fixed.dwFileVersionMS) & "." & _
                          LoWord(fixed.dwFileVersionMS) & "." & _
                          HiWord(fixed.dwFileVersionLS) & "." & _
                          LoWord(fixed.dwFileVersionLS)
    End If
End Property

Property Get FullProductVersion() As String
    If sVer = sEmpty Then
        FullProductVersion = sEmpty
    Else
        FullProductVersion = HiWord(fixed.dwProductVersionMS) & "." & _
                             LoWord(fixed.dwProductVersionMS) & "." & _
                             HiWord(fixed.dwProductVersionLS) & "." & _
                             LoWord(fixed.dwProductVersionLS)
    End If
End Property

Property Get FileVersionMajor() As Long
    FileVersionMajor = fixed.dwFileVersionMS
End Property

Property Get FileVersionMinor() As Long
    FileVersionMinor = fixed.dwFileVersionLS
End Property

Property Get ProductVersionMajor() As Long
    ProductVersionMajor = fixed.dwProductVersionMS
End Property

Property Get ProductVersionMinor() As Long
    ProductVersionMinor = fixed.dwProductVersionLS
End Property

Property Get BuildOptions() As Long
    BuildOptions = fixed.dwFileFlags
End Property

Property Get BuildString() As String
    If sVer = sEmpty Then Exit Property
    Dim s As String
    If fixed.dwFileFlags And VS_FF_DEBUG Then s = s & "Debug "
    If fixed.dwFileFlags And VS_FF_PRERELEASE Then s = s & "Prerelease "
    If fixed.dwFileFlags And VS_FF_PATCHED Then s = s & "Patched "
    If fixed.dwFileFlags And VS_FF_PRIVATEBUILD Then s = s & "PrivateBuild "
    If fixed.dwFileFlags And VS_FF_INFOINFERRED Then s = s & "InfoInferred "
    If fixed.dwFileFlags And VS_FF_SPECIALBUILD Then s = s & "SpecialBuild "
    BuildString = s
End Property

Property Get Environment() As String
    If sVer = sEmpty Then Exit Property
    Dim s As String
    Select Case LoWord(fixed.dwFileOS)
    Case VOS__WINDOWS16
        s = "Windows (16-bit)"
    Case VOS__PM16
        s = "PM (16-bit)"
    Case VOS__PM32
        s = "PM (32-bit)"
    Case VOS__WINDOWS32
        s = "Windows (32-bit)"
    End Select
    Select Case HiWord(fixed.dwFileOS)
    Case HiWord(VOS_DOS)
        s = s & " under MS-DOS"
    Case HiWord(VOS_OS216)
        s = s & " under OS/2 (16-bit)"
    Case HiWord(VOS_OS232)
        s = s & " under OS/2 (32-bit)"
    Case HiWord(VOS_NT)
        s = s & " under Windows-NT"
    End Select
    Environment = s
End Property

Property Get ExeType() As String
    If sVer = sEmpty Then Exit Property
    Dim s As String
    Select Case fixed.dwFileType
    Case VFT_APP:
        s = "Application"
    Case VFT_DLL:
        s = "Dynamic Link Library"
    Case VFT_DRV:
        s = "Driver"
        Select Case fixed.dwFileSubtype
        Case VFT2_DRV_PRINTER
            s = s & ":Printer"
        Case VFT2_DRV_KEYBOARD
            s = s & ":Keyboard"
        Case VFT2_DRV_LANGUAGE
            s = s & ":Language"
        Case VFT2_DRV_DISPLAY
            s = s & ":Display"
        Case VFT2_DRV_MOUSE
            s = s & ":Mouse"
        Case VFT2_DRV_NETWORK
            s = s & ":Network"
        Case VFT2_DRV_System
            s = s & ":System"
        Case VFT2_DRV_INSTALLABLE
            s = s & ":Installable"
        Case VFT2_DRV_SOUND
            s = s & ":Sound"
        Case VFT2_DRV_COMM
            s = s & ":Communications"
        End Select
    Case VFT_FONT:
        s = "Font"
        Select Case fixed.dwFileSubtype
        Case VFT2_FONT_RASTER
            s = s & ":Raster"
        Case VFT2_FONT_VECTOR
            s = s & ":Vector"
        Case VFT2_FONT_TRUETYPE
            s = s & ":TrueType"
        End Select
    Case VFT_VXD:
        s = "VXD"
    Case VFT_STATIC_LIB:
        s = "Static Library"
    Case Else
        s = "Unknown"
    End Select
    ExeType = s
End Property

Property Get TimeStamp() As Variant
    If fixed.dwFileDateMS = 0& And fixed.dwFileDateLS = 0& Then
        TimeStamp = 0&
    Else
        ' Implement for 32-bit
        TimeStamp = 1&
    End If
End Property

Property Get Company() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "CompanyName", pData, cData) Then
        Company = BufToStr(pData, cData)
    End If
End Property

Property Get Comments() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "Comments", pData, cData) Then
        Comments = BufToStr(pData, cData)
    End If
End Property

Property Get Description() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "FileDescription", pData, cData) Then
        Description = BufToStr(pData, cData)
    End If
End Property

Property Get ProductVersionString() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "ProductVersion", pData, cData) Then
        ProductVersionString = BufToStr(pData, cData)
    End If
End Property

Property Get FileVersionString() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "FileVersion", pData, cData) Then
        FileVersionString = BufToStr(pData, cData)
    End If
End Property


Property Get InternalName() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "InternalName", pData, cData) Then
        InternalName = BufToStr(pData, cData)
    End If
End Property

Property Get Copyright() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "LegalCopyright", pData, cData) Then
        Copyright = BufToStr(pData, cData)
    End If
End Property

Property Get Trademarks() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "LegalTradeMarks", pData, cData) Then
        Trademarks = BufToStr(pData, cData)
    End If
End Property

Property Get OriginalFilename() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "OriginalFilename", pData, cData) Then
        OriginalFilename = BufToStr(pData, cData)
    End If
End Property

Property Get PrivateBuild() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "PrivateBuild", pData, cData) Then
        PrivateBuild = BufToStr(pData, cData)
    End If
End Property

Property Get ProductName() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "ProductName", pData, cData) Then
        ProductName = BufToStr(pData, cData)
    End If
End Property

Property Get ProductVersion() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "ProductVersion", pData, cData) Then
        ProductVersion = BufToStr(pData, cData)
    End If
End Property

Property Get SpecialBuild() As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & "SpecialBuild", pData, cData) Then
        SpecialBuild = BufToStr(pData, cData)
    End If
End Property

Property Get Custom(sCustom As String) As String
    If sVer = sEmpty Then Exit Property
    If VerQueryValue(sVer, sPrefix & sCustom, pData, cData) Then
        Custom = BufToStr(pData, cData)
    End If
End Property
